src/main/java/maxempresarial/controlador/SelecaoFilialBean.java
package maxempresarial.controlador;

import java.io.Serializable;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.faces.view.ViewScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.primefaces.context.RequestContext;
import org.primefaces.model.LazyDataModel;
import org.primefaces.model.SortOrder;

import maxempresarial.modelo.Filial;
import maxempresarial.repositorio.filtro.FilialFiltro;
import maxempresarial.repositorio.pesquisa.FilialPesquisa;

@Named
@ViewScoped
public class SelecaoFilialBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private FilialPesquisa filialPesquisa;

	private FilialFiltro filtro;
	private LazyDataModel<Filial> lazyFiliais;

	public SelecaoFilialBean() {
		this.filtro = new FilialFiltro();
		this.lazyFiliais = new LazyDataModel<Filial>() {

			private static final long serialVersionUID = 1L;

			@Override
			public List<Filial> load(int primeiroRegistro, int quantidadeRegistros, String propriedadeOrdenacao, SortOrder ascendente,
					Map<String, Object> filters) {

				filtro.setPrimeiroRegistro(primeiroRegistro);
				filtro.setQuantidadeDeRegistros(quantidadeRegistros);
				filtro.setPropriedadeParaOrdenacao(propriedadeOrdenacao);
				filtro.setAscendente(SortOrder.ASCENDING.equals(ascendente));

				this.setRowCount(filialPesquisa.quantidadeFiliaisFiltradas(filtro));

				return filialPesquisa.filtradas(filtro);
			}
		};
	}

	public void selecionar(Filial filial) {
		RequestContext.getCurrentInstance().closeDialog(filial);
	}

	public void abrirDialogo() {
		Map<String, Object> opcoes = new HashMap<>();
		opcoes.put("modal", true);
		opcoes.put("resizable", false);
		opcoes.put("contentWidth", 870);
		opcoes.put("contentHeight", 670);

		RequestContext.getCurrentInstance().openDialog("/dialogos/selecaoFilial", opcoes, null);
	}

	public FilialFiltro getFiltro() {
		return filtro;
	}

	public LazyDataModel<Filial> getLazyFiliais() {
		return lazyFiliais;
	}

}

src/main/java/maxempresarial/controlador/cadastro/FilialBean.java
package maxempresarial.controlador.cadastro;

import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.PostConstruct;
import javax.faces.context.FacesContext;
import javax.faces.view.ViewScoped;
import javax.imageio.ImageIO;
import javax.inject.Inject;
import javax.inject.Named;

import org.hibernate.validator.constraints.NotBlank;
import org.primefaces.context.RequestContext;
import org.primefaces.event.SelectEvent;
import org.primefaces.model.UploadedFile;

import maxempresarial.modelo.Cidade;
import maxempresarial.modelo.Contato;
import maxempresarial.modelo.Empresa;
import maxempresarial.modelo.Endereco;
import maxempresarial.modelo.Estado;
import maxempresarial.modelo.Filial;
import maxempresarial.modelo.Pais;
import maxempresarial.modelo.Telefone;
import maxempresarial.modelo.enumTipo.RamoAtividade;
import maxempresarial.modelo.enumTipo.TipoTelefone;
import maxempresarial.modelo.enumTipo.TiposSimplesNacional;
import maxempresarial.modelo.enumTipo.TiposSimplesNacionalIssqn;
import maxempresarial.repositorio.dao.ExcecaoDAO;
import maxempresarial.repositorio.filtro.CidadeFiltro;
import maxempresarial.repositorio.filtro.EstadoFiltro;
import maxempresarial.repositorio.filtro.PaisFiltro;
import maxempresarial.repositorio.pesquisa.CidadePesquisa;
import maxempresarial.repositorio.pesquisa.EstadoPesquisa;
import maxempresarial.repositorio.pesquisa.PaisPesquisa;
import maxempresarial.servico.ExcecaoRN;
import maxempresarial.servico.FilialServico;
import maxempresarial.util.jsf.FacesUtil;

@Named
@ViewScoped
public class FilialBean implements Serializable {

	private static final long serialVersionUID = 1L;

	@Inject
	private FilialServico filialServico;

	@Inject
	private EstadoPesquisa estadoPesquisa;

	@Inject
	private CidadePesquisa cidadePesquisa;

	@Inject
	private PaisPesquisa paisPesquisa;

	private Filial filial;
	private Endereco endereco;
	private Contato contato;
	private Telefone telefone;
	private UploadedFile uploadArquivo;

	private List<Estado> estadosEndereco;
	private List<Estado> estadosTelefone;
	private List<Cidade> cidades;
	private List<Pais> paises = new ArrayList<>();

	public FilialBean() {
		this.limpar();
	}

	@PostConstruct
	public void inicializar() {
		if (this.filial == null) {
			this.limpar();
		}
		this.paises = this.paisPesquisa.filtrados(new PaisFiltro());
	}

	private void limpar() {
		this.filial = new Filial();
		this.endereco = new Endereco();
		this.estadosEndereco = new ArrayList<>();
		this.estadosTelefone = new ArrayList<>();
		this.cidades = new ArrayList<>();
		this.contato = new Contato();
		this.telefone = new Telefone();
	}

	public void adicionarEndereco() {
		this.endereco = new Endereco();
		this.estadosEndereco = new ArrayList<>();
		this.cidades = new ArrayList<>();
	}

	public void adicionarContato() {
		this.contato = new Contato();
	}

	public void adicionarTelefone() {
		this.telefone = new Telefone();
		this.estadosTelefone = new ArrayList<>();
	}

	public void salvarFilial() {
		try {
			if (this.uploadArquivo != null) {
				this.filial.setLogo(this.uploadArquivo.getContents());
			}
			this.filial = this.filialServico.salvar(this.filial);
			this.limpar();

			FacesUtil.mensagemInformacao(FacesUtil.getMensagemInternacionalizacao("salvo_corretamente_mensagem"),
					FacesUtil.getMensagemInternacionalizacao("salvo_corretamente_detalhes"));
		} catch (ExcecaoRN ern) {
			FacesUtil.mensagemAviso(FacesUtil.getMensagemInternacionalizacao("atencao_mensagem"), FacesUtil.getMensagemInternacionalizacao(ern.getMessage()));
		} catch (ExcecaoDAO edao) {
			FacesUtil.mensagemErro(FacesUtil.getMensagemInternacionalizacao("salvo_falha_mensagem"), edao.getMessage());
		}
	}

	public void inserirEndereco() {
		RequestContext context = RequestContext.getCurrentInstance();
		boolean adicionado = false;

		if (this.endereco.getPk() == null) {
			this.filial.getEnderecos().add(this.endereco);
			adicionado = true;
			this.endereco = new Endereco();
			FacesUtil.mensagemInformacao(FacesUtil.getMensagemInternacionalizacao("inserido_corretamente_mensagem"),
					FacesUtil.getMensagemInternacionalizacao("inserido_corretamente_detalhes"));
		} else if (this.endereco != null) {
			adicionado = true;
			FacesUtil.mensagemInformacao(FacesUtil.getMensagemInternacionalizacao("inserido_corretamente_mensagem"),
					FacesUtil.getMensagemInternacionalizacao("inserido_corretamente_detalhes"));
		}
		context.addCallbackParam("adicionado", adicionado);
	}

	public void inserirContato() {
		RequestContext context = RequestContext.getCurrentInstance();
		boolean adicionado = false;

		if (this.contato.getPk() == null) {
			this.filial.getContatos().add(this.contato);
			adicionado = true;
			this.contato = new Contato();
			FacesUtil.mensagemInformacao(FacesUtil.getMensagemInternacionalizacao("inserido_corretamente_mensagem"),
					FacesUtil.getMensagemInternacionalizacao("inserido_corretamente_detalhes"));
		} else if (this.contato != null) {
			adicionado = true;
			FacesUtil.mensagemInformacao(FacesUtil.getMensagemInternacionalizacao("inserido_corretamente_mensagem"),
					FacesUtil.getMensagemInternacionalizacao("inserido_corretamente_detalhes"));
		}
		context.addCallbackParam("adicionado", adicionado);
	}

	public void inserirTelefone() {
		RequestContext context = RequestContext.getCurrentInstance();
		boolean adicionado = false;

		if (this.telefone.getPk() == null) {
			this.filial.getTelefones().add(this.telefone);
			adicionado = true;
			this.telefone = new Telefone();
			FacesUtil.mensagemInformacao(FacesUtil.getMensagemInternacionalizacao("inserido_corretamente_mensagem"),
					FacesUtil.getMensagemInternacionalizacao("inserido_corretamente_detalhes"));
		} else if (this.telefone != null) {
			adicionado = true;
			FacesUtil.mensagemInformacao(FacesUtil.getMensagemInternacionalizacao("inserido_corretamente_mensagem"),
					FacesUtil.getMensagemInternacionalizacao("inserido_corretamente_detalhes"));
		}
		context.addCallbackParam("adicionado", adicionado);
	}

	public void abrirDialogoCidade() {
		Map<String, Object> opcoes = new HashMap<>();
		opcoes.put("modal", true);
		opcoes.put("resizable", false);
		opcoes.put("contentHeight", 470);

		RequestContext.getCurrentInstance().openDialog("/dialogos/selecaoCidade", opcoes, null);
	}

	public void selecionarCidade(Cidade cidade) {
		RequestContext.getCurrentInstance().closeDialog(cidade);
	}

	public void cidadeSelecionada(SelectEvent event) {
		this.telefone.setDdd((Cidade) event.getObject());
	}

	public void excluirEndereco() {
		if (this.endereco != null) {
			this.filial.getEnderecos().remove(this.endereco);
		}
	}

	public void excluirContato() {
		if (this.contato != null) {
			this.filial.getContatos().remove(this.contato);
		}
	}

	public void excluirTelefone() {
		if (this.telefone != null) {
			this.filial.getTelefones().remove(this.telefone);
		}
	}

	public void empresaSelecionada(SelectEvent event) {
		this.filial.setEmpresa((Empresa) event.getObject());
	}

	public boolean isEditandoFilial() {
		return this.filial.getPk() != null;
	}

	public boolean isFaseRenderizacao() {
		if (FacesContext.getCurrentInstance().getCurrentPhaseId().getName().equals("RENDER_RESPONSE")) {
			return true;
		} else {
			return false;
		}

	}

	public TiposSimplesNacional[] getTiposSimplesNacional() {
		return TiposSimplesNacional.values();
	}

	public TiposSimplesNacionalIssqn[] getTiposSimplesNacionalIssqn() {
		return TiposSimplesNacionalIssqn.values();
	}

	public TipoTelefone[] getTipoTelefone() {
		return TipoTelefone.values();
	}

	public RamoAtividade[] getRamo() {
		return RamoAtividade.values();
	}

	public Filial getFilial() {
		return filial;
	}

	public void setFilial(Filial filial) {
		this.filial = filial;
	}

	public Endereco getEndereco() {
		return endereco;
	}

	public void setEndereco(Endereco endereco) {
		this.endereco = endereco;
	}

	public Contato getContato() {
		return contato;
	}

	public void setContato(Contato contato) {
		this.contato = contato;
	}

	public Telefone getTelefone() {
		return telefone;
	}

	public void setTelefone(Telefone telefone) {
		this.telefone = telefone;
	}

	public List<Estado> getEstadosEndereco() {
		this.estadosEndereco.clear();
		if (this.endereco.getPais() != null) {
			EstadoFiltro filtro = new EstadoFiltro();
			filtro.setPais(this.telefone.getDdi());
			return estadosEndereco = this.estadoPesquisa.filtrados(filtro);
		}
		return null;
	}

	public List<Estado> getEstadosTelefone() {
		this.estadosTelefone.clear();
		if (this.telefone.getDdi() != null) {
			EstadoFiltro filtro = new EstadoFiltro();
			filtro.setPais(this.telefone.getDdi());
			return estadosTelefone = this.estadoPesquisa.filtrados(filtro);
		}
		return null;
	}

	public List<Cidade> getCidades() {
		this.cidades.clear();
		if (this.endereco.getEstado() != null) {
			CidadeFiltro filtro = new CidadeFiltro();
			filtro.setEstado(this.endereco.getEstado());
			return cidades = this.cidadePesquisa.filtrados(filtro);
		}
		return null;
	}

	public List<Pais> getPaises() {
		return paises;
	}

	public UploadedFile getUploadArquivo() {
		return uploadArquivo;
	}

	public void setUploadArquivo(UploadedFile uploadArquivo) {
		this.uploadArquivo = uploadArquivo;
	}

	public BufferedImage getLogo() throws IOException {
		if (this.filial.getLogo() != null) {
			return ImageIO.read(new ByteArrayInputStream(this.filial.getLogo()));
		}
		return null;
	}

	@NotBlank(message = "Empresa não pode esta vazia.")
	public String getNomeEmpresa() {
		return this.filial.getEmpresa() == null ? null : this.filial.getEmpresa().getNomeFantasia();
	}

	// metodo para burlar erro do JSF
	public void setNomeEmpresa(String nome) {
	}

	@NotBlank(message = "DDD não pode esta vazia.")
	public String getDdd() {

src/main/webapp/dialogos/selecaoCidade.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:h="http://xmlns.jcp.org/jsf/html" xmlns:f="http://xmlns.jcp.org/jsf/core"
	xmlns:ui="http://xmlns.jcp.org/jsf/facelets" xmlns:p="http://primefaces.org/ui">
<h:head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta name="viewport" content="width=device-width,initial-scale=1" />
	<title>#{msg.subtitulo_dialogo_selecao_empresa}</title>
	<h:outputStylesheet library="css" name="sistema.css" />
</h:head>
<h:body>

	<h:form id="frmPesquisaCidade">

		<p:panelGrid id="painelPesquisaCidade" columns="3" columnClasses="ui-grid-col-1,ui-grid-col-5,ui-grid-col-1" layout="grid" styleClass="ui-panelgrid-blank">

			<p:outputLabel value="#{msg.label_pesquisa_cidade_nome}" for="nome" styleClass="estilo-campo" />
			<p:inputText id="nome" value="#{cidadeBean.filtro.nome}" styleClass="estilo-campo" placeholder="asdf" />
			<p:commandButton value="#{msg.botao_pesquisa}" update=":frmPesquisaCidade:tabelaCidades" />

		</p:panelGrid>

		<p:dataTable id="tabelaCidades" var="cidade" value="#{cidadeBean.lazyCidades}" reflow="true" emptyMessage="#{msg.datatable_pesquisa_menssagem}" rows="35"
			paginator="true" paginatorPosition="bottom" lazy="true" rowsPerPageTemplate="20,35,50"
			paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}">

			<p:column headerText="#{msg.cadastro_cidade_ddd}">
				<h:outputText value="#{cidade.ddd}" />
			</p:column>

			<p:column headerText="#{msg.cadastro_cidade_nome}">
				<h:outputText value="#{cidade.nome}" />
			</p:column>

			<p:column headerText="#{msg.cadastro_cidade_estado}">
				<h:outputText value="#{cidade.estado.nome}" />
			</p:column>

			<p:column styleClass="coluna-opcoes" headerText="#{msg.botao_dialogo_coluna_selecionar}">
				<p:commandButton icon="fa fa-check-square-o" style="width: 30px;" process="@this" action="#{empresaBean.selecionarCidade(cidade)}" />
			</p:column>
		</p:dataTable>
	</h:form>
</h:body>
</html>

src/main/webapp/dialogos/selecaoEmpresa.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:h="http://xmlns.jcp.org/jsf/html" xmlns:f="http://xmlns.jcp.org/jsf/core"
	xmlns:ui="http://xmlns.jcp.org/jsf/facelets" xmlns:p="http://primefaces.org/ui">
<h:head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta name="viewport" content="width=device-width,initial-scale=1" />
	<title>#{msg.subtitulo_dialogo_selecao_empresa}</title>
	<h:outputStylesheet library="css" name="sistema.css" />
</h:head>
<h:body>

	<h:form id="frmPesquisaEmpresa">

		<p:panelGrid id="painelPesquisaEmpresa" columns="3" columnClasses="ui-grid-col-1,ui-grid-col-5,ui-grid-col-1" layout="grid" styleClass="ui-panelgrid-blank">

			<p:outputLabel value="#{msg.label_pesquisa_empresa_nome}:" for="nome" styleClass="estilo-campo" />
			<p:inputText id="nome" value="#{pesquisaEmpresaBean.filtro.nomeFantasia}" styleClass="estilo-campo" placeholder="nome fantasia" />
			<p:commandButton value="#{msg.botao_pesquisa}" update="frmPesquisaEmpresa:tabelaEmpresas" />

		</p:panelGrid>

		<p:dataTable id="tabelaEmpresas" var="empresa" value="#{pesquisaEmpresaBean.lazyEmpresas}" reflow="true" emptyMessage="#{msg.datatable_pesquisa_msg}"
			rows="35" paginator="true" paginatorPosition="bottom" lazy="true" rowsPerPageTemplate="20,35,50"
			paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}">

			<p:column headerText="#{msg.datatable_pesquisa_empresa_nome_fantasia}">
				<h:outputText value="#{empresa.nomeFantasia}" />
			</p:column>

			<p:column headerText="#{msg.datatable_pesquisa_empresa_razao_social}">
				<h:outputText value="#{empresa.razaoSocial}" />
			</p:column>

			<p:column headerText="#{msg.datatable_pesquisa_empresa_cnpj}" style="width: 180px;">
				<h:outputText value="#{empresa.cnpj}" />
			</p:column>

			<p:column headerText="#{msg.datatable_pesquisa_empresa_responsavel}" style="width: 150px;">
				<h:outputText value="#{empresa.responsavel}" />
			</p:column>

			<p:column headerText="#{msg.datatable_pesquisa_empresa_ramo}" style="width: 90px;">
				<h:outputText value="#{empresa.ramo.descricao}" />
			</p:column>

			<p:column styleClass="coluna-opcoes" headerText="#{msg.botao_dialogo_coluna_selecionar}">
				<p:commandButton icon="fa fa-check-square-o" style="width: 30px;" process="@this" action="#{empresaBean.selecionar(empresa)}" />
			</p:column>
		</p:dataTable>
	</h:form>
</h:body>
</html>

src/main/webapp/dialogos/selecaoFilial.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:h="http://xmlns.jcp.org/jsf/html" xmlns:f="http://xmlns.jcp.org/jsf/core"
	xmlns:ui="http://xmlns.jcp.org/jsf/facelets" xmlns:p="http://primefaces.org/ui">
<h:head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta name="viewport" content="width=device-width,initial-scale=1" />
	<title>#{msg.subtitulo_dialogo_selecao}</title>
	<h:outputStylesheet library="css" name="sistema.css" />
</h:head>
<h:body>

	<h:form id="frmPesquisaFilial">

		<p:panelGrid id="painelPesquisaFilial" columns="3" columnClasses="ui-grid-col-1,ui-grid-col-5,ui-grid-col-1" layout="grid" styleClass="ui-panelgrid-blank">

			<p:outputLabel value="#{msg.label_pesquisa_filial_nome}" for="nome" styleClass="estilo-campo" />
			<p:inputText id="nome" value="#{selecaoFilialBean.filtro.nomeFantasia}" styleClass="estilo-campo" placeholder="#{msg.cadastro_filial_placeholder_nome}" />
			<p:commandButton value="#{msg.botao_pesquisa}" update=":frmPesquisaFilial:tabelaFiliais" />

		</p:panelGrid>

		<p:dataTable id="tabelaFiliais" var="filial" value="#{selecaoFilialBean.lazyFiliais}" reflow="true" emptyMessage="#{msg.datatable_pesquisa_menssagem}"
			rows="35" paginator="true" paginatorPosition="bottom" lazy="true" rowsPerPageTemplate="20,35,50"
			paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}">

			<p:column headerText="#{msg.cadastro_filial_nome_fantasia}">
				<h:outputText value="#{filial.nomeFantasia}" />
			</p:column>

			<p:column headerText="#{msg.cadastro_filial_razao_social}">
				<h:outputText value="#{filial.razaoSocial}" />
			</p:column>

			<p:column headerText="#{msg.cadastro_filial_cnpj}" style="width: 180px;">
				<h:outputText value="#{filial.cnpj}" />
			</p:column>

			<p:column headerText="#{msg.cadastro_filial_responsavel}" style="width: 150px;">
				<h:outputText value="#{filial.responsavel}" />
			</p:column>

			<p:column headerText="#{msg.cadastro_filial_selectonemenu_ramo}" style="width: 90px;">
				<h:outputText value="#{filial.ramo.descricao}" />
			</p:column>

			<p:column styleClass="coluna-opcoes" headerText="#{msg.botao_dialogo_coluna_selecionar}">
				<p:commandButton icon="fa fa-check-square-o" style="width: 30px;" process="@this" action="#{selecaoFilialBean.selecionar(filial)}" />
			</p:column>
		</p:dataTable>
	</h:form>
</h:body>
</html>